<?php
/*
※ファイルのURL→http://～/d/年/月日/UNIXTime.拡張子
*/

new UPLOAD();

class UPLOAD{
	private $savedir = 'd';
	private $filepermission  = 0666;
	private $blacklist = array('php', 'cgi', 'fcgi', 'pl', 'py', 'rb', 'asp', 'aspx', 'jsp', 'htaccess', 'htpasswd');//ホワイトリスト形式にすべきだが
	private $limit = array();
	private $result = array();
	
	function UPLOAD(){
		error_reporting(0);
		session_start();
		$this->limit['php_upload_max_filesize'] = ini_get('upload_max_filesize');
		$this->limit['php_post_max_size']       = ini_get('post_max_size');
		$this->limit['php_max_file_uploads']    = ini_get('max_file_uploads');
		$this->limit['byte'] = preg_replace('/M/i', '', $this->limit['php_post_max_size']);//決め打ち
		$this->limit['byte'] = $this->limit['byte'] * 1000 *1000;
		

		if($_SERVER['REQUEST_METHOD'] == 'POST'){
			$this->RecieveUpload();
		}
		else{
			$this->PrintTopPage();
		}
	}

	
	function RecieveUpload(){
		if($_SESSION['time'] != $_GET['time']){ $this->PrintResult('二重投稿です。', 'error'); }
		unset($_SESSION['time']);
		
		if ($_FILES[uploadfile][error] === UPLOAD_ERR_OK and $_FILES[uploadfile][name]){//単数
			$this->SaveFile($_FILES[uploadfile][tmp_name], $_FILES[uploadfile][name], $_SERVER['REQUEST_TIME']);
		}
		elseif($_FILES[uploadfile][error][0] === UPLOAD_ERR_OK and $_FILES[uploadfile][name][0]){//複数
			for ($i=0; $i<$this->limit['php_max_file_uploads']; $i++) {
				if($_FILES[uploadfile][error][$i] != 0 or !$_FILES[uploadfile][name][$i]){ break; }
				$this->SaveFile($_FILES[uploadfile][tmp_name][$i], $_FILES[uploadfile][name][$i], $_SERVER['REQUEST_TIME']+$i);
			}
		}
		elseif($_FILES[uploadfile][error] === UPLOAD_ERR_NO_FILE or $_FILES[uploadfile][error][0] === UPLOAD_ERR_NO_FILE){//失敗
			$this->PrintResult('ファイルを選択してください。', 'error');
		}
		else{//失敗
			$this->PrintResult('アップロードに失敗しました。', 'error');
		}
		
		$copyform = $this->CopyForm();
		$table    = "<table><tr><th>ファイル</th><th>URL</th></tr>\n{$this->result['tr']}</table>";
		$this->PrintResult('アップロードに成功しました。URLをコピーしておいてください。', 'success', "$copyform$table");
	}


	function SaveFile($tmpfile, $upfile, $time){
		$savedir1 = date('Y'   , $time);
		$savedir2 = date('md'  , $time);
		$filename = $time;
		
		$this->MakeDir($this->savedir, $savedir1);
		$this->MakeDir("$this->savedir/$savedir1", $savedir2);

		$extension = pathinfo($upfile, PATHINFO_EXTENSION);
		if($extension){
			if(!ctype_alnum($extension)){ $this->PrintResult('拡張子は英数字限定です。', 'error'); }
			foreach($this->blacklist as $ng){
				if($ng == $extension){ $extension = 'txt'; }
			}
			$filename = "$filename.$extension";
		}

		$filepath = "$this->savedir/$savedir1/$savedir2/{$filename}";
		if(@move_uploaded_file($tmpfile, $filepath) === false){
			$this->PrintResult('ファイルが作成できません', 'error');
		}
		chmod($filepath, $this->filepermission);

		$fileurl = $this->Path2URL($filepath);
		$upfile = htmlspecialchars($upfile);
		
		$fromencode = 'auto';
		//if(preg_match("/Windows/i", $_SERVER['HTTP_USER_AGENT'])){ $fromencode = "SJIS"; }
		$upfile = mb_convert_encoding($upfile, 'UTF-8', $fromencode);
		
		$this->result['tr'] .= "<tr><td><a href=\"$fileurl\" target=\"_blank\">$upfile</a></td><td>$fileurl</td></tr>\n";
		$this->result['fileurl'] .= "$fileurl\n";
	}


	function MakeDir($path, $name){//ディレクトリを作るパスとディレクトリ名を頂戴
		if(!is_dir("$path/$name")){
			$permission = substr(decoct(fileperms($path)), 1);
			$flag = mkdir("$path/$name", octdec($permission));// umaskでパーミッションが減るから
			chmod("$path/$name", octdec($permission));// ここで元に戻す
			if(!$flag){ $this->PrintResult('ディレクトリが作成できません', 'error'); }
		}
	}


	function Path2URL($path){ //相対パスを頂戴
		if($_SERVER['HTTPS']=='on'){ $protocol = 'https://'; }
		else{ $protocol = 'http://'; }
		
		$dir_url = preg_replace('/\/[^\/]*$/', '/', $_SERVER['REQUEST_URI']); //$_SERVER['REQUEST_URI']からファイル名以下を消す
		$dir_url = preg_replace('/^\//', '', $dir_url); //先頭の/が邪魔なので消しておく

		$path = preg_replace('/^\.\//', '', $path); //現在のフォルダに対応
		if(preg_match('/^\.\.\//', $path)){ //上位のフォルダに対応する
			$path = str_replace('../', '', $path, $count);
			$dirlist = explode('/', $dir_url);
			array_splice($dirlist, -$count-1);
			if(count($dirlist)>0){
				$dir_url = implode('/', $dirlist) . '/';
			}
			else{
				$dir_url = '';
			}
		}

		$url = $protocol . $_SERVER['HTTP_HOST'] . '/' . $dir_url . $path;
		return $url;
	}

	function PrintTopPage(){
		$nav = "";
		$_SESSION['time'] = $_SERVER['REQUEST_TIME'];
		
		print <<<END_OF_LINE
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="utf-8">
  <title>アップローダ</title>
  <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"></script>
  <link href="style.css" rel="stylesheet">
</head>
<body id="upload">
<nav><a href="uplist.php">アップリスト</a></nav>
<form action="upload.php?time={$_SERVER['REQUEST_TIME']}" method="POST" enctype="multipart/form-data" id="upform">
<input type="hidden" name="MAX_FILE_SIZE" value="{$this->limit['byte']}">
<input type="file" class="upfile" name="uploadfile[]" onchange="add_file('uploadfile', 1);"><br>
<span id="uploadfile_1"></span>
<input type="submit" class="upsubmit" name="submit" value="ファイルをアップロードする">
<p class="mininote">※合計<strong>{$this->limit['php_post_max_size']}B</strong>までアップロードできます。</p>
</form>


<script language="JavaScript">
function add_file(id, i) {
	var elements = document.getElementsByName("uploadfile[]");
	if (elements.length >= {$this->limit['php_max_file_uploads']}){ return; }
	if (document.getElementById(id + '_' + i).innerHTML.search('upfile') == -1) {
		document.getElementById(id + '_' + i).innerHTML = '<input type="file" class="upfile" name="' + id + '[]" onchange="return add_file(\'' + id + '\', ' + (i+1) + ');" /><br /><span id="' + id + '_' + (i+1) + '"><\/span>';
	}
}
</script>


</body>
</html>


END_OF_LINE;
		exit;
	}
	
	
	function PrintResult($str, $flag, $addhtml = ""){
		$y  = date('Y',  $_SERVER['REQUEST_TIME']);
		$md = date('md', $_SERVER['REQUEST_TIME']);
		$link = "<a href=\"uplist.php?y={$y}&md={$md}\">アップリスト</a>";
		if($flag=="error"){	$link = "<a href=\"upload.php\">アップロード</a>";}
		
		header("Cache-Control: no-cache");
		print <<<END_OF_LINE
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="utf-8">
  <title>アップローダ</title>
  <link href="style.css" rel="stylesheet">
</head>
<body>

<p class="$flag">$str</p>
{$addhtml}

<br>{$link}
</body>
</html>

END_OF_LINE;
		exit;
	}


	function CopyForm(){
		$copyform .= "<object id=\"external_setclipboard\" width=\"110\" height=\"25\" align=\"middle\" classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\">\n";
		$copyform .= "<param name=\"movie\" value=\"setClipboard10.swf\">\n";
		$copyform .= "<param name=\"FlashVars\" value=\"htmlid=copypaste&label=URLをコピーする\">\n";
		$copyform .= "<param name=\"allowScriptAccess\" value=\"sameDomain\">\n";
		$copyform .= "</object><br>\n<textarea style=\"display:none;\" cols=\"100\" rows=\"10\" id=\"copypaste\">{$this->result['fileurl']}</textarea>\n";
		return $copyform;
	}

}